/* 	CfDetailView.java
 *	Copyright (c) 2010, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Jun 18, 2010
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.gui;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.event.FocusListener;

import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JRootPane;

import org.brains2b.coffee.event.CoffeeExchange;
import org.brains2b.coffee.message.Article;
import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.plugin.CoffeeExchangeView;
import org.brains2b.swingext.dialog.DialogHelper;
import org.brains2b.swingext.form.Form;
import org.brains2b.swingext.form.FormAction;

/**
 * Allow for opening an article from a list to a detail dialog
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version $Revision: 1.1 $ $Date: 2010/07/05 00:38:34 $
 */
public class CfDetailView extends JPanel implements CoffeeExchangeView {

	class FormHandler implements Form {

		public JRootPane getRootPane() {
			return CfDetailView.this.getRootPane();
		}

		public void performApply() {
		}

		public void performCancel() {
		}

		public void performOk() {
			DialogHelper.getWindowPane(CfDetailView.this).dispose();
		}

		public void performUndo() {
			
		}
		
	}
	
	private CfPreviewPane m_preview;
	
	public CfDetailView() {
		init();
	}
	
	private void init() {
		setLayout(new BorderLayout());
		m_preview = new CfPreviewPane(this);
		add(m_preview,BorderLayout.CENTER);
		add(new FormAction(new FormHandler(),FormAction.BTN_OK),BorderLayout.SOUTH);
	}
	public void activate() {
		m_preview.setEnabled(false);
		setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	}

	public void addFocusListener(FocusListener f) {
		
	}

	public void deactivate() {
		setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	}

	public void fireCoffeeEvent(CoffeeExchange source, int action,
			Object argument) {

	}

	public JMenu[] getMenus() {
		return null;
	}

	public int getSelectEvent(int messageType) {
		return 0;
	}

	public boolean isVisible() {
		return super.isVisible();
	}

	public void removeFocusListener(FocusListener f) {
		
	}

	public void setCurrentMessage(NNTPMessage message) {
		if (message instanceof Article) {
			setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
			m_preview.setEnabled(true);
			m_preview.setArticle((Article) message);
		}
	}

}
