/* 	CfStatsDelegate.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 12-aug-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * TODO class in addStats() should be used to link determine type of message
 * TODO Delegates should be fired by a listener		
*/
package org.brains2b.coffee.gui;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

import org.brains2b.coffee.event.CoffeeExchange;
import org.brains2b.coffee.message.Article;
import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.message.filter.FilterTarget;
import org.brains2b.coffee.plugin.CoffeeExchangeView;

public class CfStatsDelegate implements CoffeeExchange {
    
    private JLabel m_label;
    
    public  CfStatsDelegate(CoffeeExchangeView view) {
        super();
    }

    public JLabel addStats(Class c) {
        m_label=new JLabel();
        m_label.setBorder(BorderFactory.createEmptyBorder(2,5,2,5));
        m_label.setHorizontalAlignment(SwingConstants.RIGHT);
        m_label.setFont(m_label.getFont().deriveFont(9f));
        return m_label;
    }

    public void setCurrentMessage(NNTPMessage message) {
        String text=null;
        if (message instanceof FilterTarget) {
            text= ((FilterTarget) message).getFilteredSize() + "/" + message.getSize();
        } else if (message instanceof Article) {
            text=String.valueOf(((Article)message).getTotalParts()) + " posts";
        } else {
            text=String.valueOf(message.getSize());
        }
        m_label.setText(text);
    }
}
