package org.brains2b.coffee.gui;

import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import org.brains2b.coffee.message.NewsGroup;
import org.brains2b.swingext.gui.IconFactory;

public class NewsGroupRenderer extends JLabel implements ListCellRenderer {

	private int m_showDepth;
	
	public NewsGroupRenderer() {
		this(99);
	}
	
	public NewsGroupRenderer(int showDepth) {
		m_showDepth = showDepth;
	}
	
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
        NewsGroup ng = (NewsGroup) value;
        if (ng==null) return new JLabel();
        String name = ng.getName();
        
        if (m_showDepth!=0) {
        	setToolTipText(name);
        }
        name = makeName(name,m_showDepth);
        
        setText(name);
        setOpaque(true);
        setIcon(IconFactory.createIcon("/org/brains2b/coffee/resource/News24.gif"));
        if (isSelected) {
            setBackground(list.getSelectionBackground());
        } else {
            setBackground(list.getBackground());
        }
        return this;
    }
    
	private String makeName(String name, int depth) {
		if (depth==0 || name==null) return name;
		StringBuffer sb = new StringBuffer();
		String[] parts = name.split("\\.");
		int cnt = Math.min(parts.length-1,depth);
		for (int i=0;i<parts.length;i++) {
			if (i<cnt) {
				sb.append(parts[i].charAt(0)).append('.');
			} else {
				sb.append(parts[i]);
				if (i<parts.length-1) sb.append('.');
			}
		}
		
		return sb.toString();
	}
}