/* 	CfCoffeeMenu.java
 *	Copyright (c) 2006-2008, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 15-dec-2006
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * Feb 26, 2008	dennis@brains2b.nl		implemented CoffeeExchangeView.getSelectEvent()		
*/
package org.brains2b.coffee.gui.settings;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.event.ChangeListener;

import org.brains2b.coffee.TicketBroker;
import org.brains2b.coffee.event.CoffeeEvent;
import org.brains2b.coffee.event.CoffeeExchange;
import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.message.local.CoffeeBean;
import org.brains2b.coffee.message.local.CoffeeMenu;
import org.brains2b.swingext.dialog.DialogHelper;
import org.brains2b.swingext.gui.list.ExtMutableList;

public class CfCoffeeList extends JPanel implements ActionListener, CfOptionView {
    
    private ExtMutableList m_list;
    private CfOptionView m_detail;
    private String m_messageId;
    
    public CfCoffeeList(String id, CfOptionView detail) {
        super();
       	m_messageId = id;
        m_detail = detail;
        init();
    }
    
    
     private void init() {
        setLayout(new BorderLayout()); 
        m_list= new ExtMutableList();
        m_list.addActionListener(this);
        add(m_list,BorderLayout.CENTER);
    }
    
    public void actionPerformed(ActionEvent e) {
    	String actionCommand = e.getActionCommand();
        if ("ExtMutableList.Remove".equals(actionCommand)) {
            fireCoffeeEvent(this, CoffeeEvent.LIST_REMOVE,m_list.getSelectedValue()); 
        } else if (actionCommand.startsWith("ExtMutableList")){
           	CoffeeBean bean = null;
            if (actionCommand.endsWith("Edit")) {
                bean = (CoffeeBean) m_list.getSelectedValue();
            }
            m_detail.setCurrentMessage(bean);
            DialogHelper.showDialog(this, (JComponent) m_detail,getShortTitle());
            
        }
        fireCoffeeEvent(this, CoffeeEvent.GET_LIST, getMessageId());
    }


    public Icon getIcon() {
        return m_detail.getIcon();
    }


    public String getMessageId() {
        return m_messageId;
    }

    public String getShortTitle() {
        return m_messageId;
    }

    public void setCurrentMessage(NNTPMessage message) {
        if (getMessageId().equals(message.getId())) {
            NNTPMessage[] items = ((CoffeeMenu) message).getArray();
            m_list.setData(items);
        }
    }


    public void activate() {
        fireCoffeeEvent(this, CoffeeEvent.GET_LIST, getMessageId());
    }


    public void deactivate() {
    }


    public void fireCoffeeEvent(CoffeeExchange source, int action, Object argument) {
        TicketBroker.getBroker().broker(new CoffeeEvent(source,action,argument));
        
    }


    public JMenu[] getMenus() {
       return null;
    }


	public void addChangeListener(ChangeListener l) {
		listenerList.add(ChangeListener.class, l);
		
	}

	public void removeChangeListener(ChangeListener l) {
		listenerList.remove(ChangeListener.class, l);
	}
	
	public int getSelectEvent(int messageType) {
    	return CoffeeEvent.NONE;
	}
}
