/* 	CfOptions.java
 *	Copyright (c) 2006, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 15-dec-2006
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * Feb 26, 2008	dennis@brains2b.nl		implemented CoffeeExchangeView.getSelectEvent()		
*/
package org.brains2b.coffee.gui.settings;

import java.awt.BorderLayout;

import javax.swing.JComponent;
import javax.swing.JMenu;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.brains2b.coffee.TicketBroker;
import org.brains2b.coffee.event.CoffeeEvent;
import org.brains2b.coffee.event.CoffeeExchange;
import org.brains2b.coffee.message.NNTPMessage;
import org.brains2b.coffee.plugin.CoffeeExchangeView;
import org.brains2b.swingext.form.Form;
import org.brains2b.swingext.form.FormAction;

public class CfOptions extends JPanel implements CoffeeExchangeView, Form {
    
    private class TabHandler implements ChangeListener {

        public void stateChanged(ChangeEvent e) {
            CfOptionView option = (CfOptionView) ((JTabbedPane) e.getSource()).getSelectedComponent();
            option.activate();
        }
        
    }
    
    private JTabbedPane m_tab;
    
    public CfOptions() {
        super();
        init();
    }

    public void setCurrentMessage(NNTPMessage message) {
        for (int i=0;i<m_tab.getComponentCount();i++) {
            CfOptionView view =(CfOptionView) m_tab.getComponentAt(i);
            if (view.getMessageId()==message.getId()) {
                view.setCurrentMessage(message);
            }
        }
    }
    
    public void performCancel() {
       SwingUtilities.getWindowAncestor(this).dispose();
        
    }

    public void performOk() {
        SwingUtilities.getWindowAncestor(this).dispose();
    }
    
    private void init() {
        setLayout(new BorderLayout());
        m_tab=new JTabbedPane();
        m_tab.addChangeListener(new TabHandler());
        add(m_tab,BorderLayout.CENTER);
        add(new FormAction(this,FormAction.BTN_OK_CANCEL),BorderLayout.SOUTH);
        
        
    }
    
    public void addOptionView(CfOptionView view) {
        m_tab.addTab(view.getShortTitle(),view.getIcon(),(JComponent) view);
    }
    
    public void fireCoffeeEvent(CoffeeExchange source, int action, Object argument) {
       TicketBroker.getBroker().broker(new CoffeeEvent(source,action,argument));
        
    }

    public JMenu[] getMenus() {
        return null;
    }

    public void activate() {
    }
    public void deactivate() {
    }
    public void performApply() {
    }
    public void performUndo() {
    }

    public int getSelectEvent(int messageType) {
    	return CoffeeEvent.NONE;
	}
}
