/* 	TreeMaker.java
 *	Copyright (c) 2007, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 3-jan-2007
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/* @#History
 * [When]		[Who]					[What]
 * 22-05-2008	dennis@brains2b.nl		synchronize order 		
 */
package org.brains2b.coffee.gui.table;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;

import org.brains2b.coffee.message.Article;

public class TreeMaker {

    
    public synchronized static final ArticleNode order(String groupName, List articles) {
        ArticleNode root=new ArticleNode(groupName);
        if (articles==null || articles.isEmpty()) {
            return root;
        }
        
        for (Iterator it = articles.iterator();it.hasNext();) {
            Article a = (Article) it.next();
            link(root,a);  
        }
        return root;
    }
    
    private final static void link(ArticleNode root, Article a) {
        String links[] =getLinks(a.getHeader().getHeaderValue("References"));
        boolean found=false;
        if (links!=null) {
            ArticleNode node=root;
            for (int i=0;i<links.length;i++) {
                for (int j=0;j<node.getChildCount();j++) {
                    if (links[i].equals(((ArticleNode) node.getChildAt(j)).getArticle().getId())) {
                        if (i==links.length-1) {
                            ((ArticleNode) node.getChildAt(j)).add(new ArticleNode(a));
                            found=true;
                        } else {
                            node=(ArticleNode) node.getChildAt(j);
                        }
                    }
                }
            }
        }
        if (!found) {
            root.add(new ArticleNode(a));
        }
    }
    
    private final static String[] getLinks(String s) {
        if (s==null || s.length()==0 || s.indexOf("<")==-1) {
            return null;
        }
        StringTokenizer t=new StringTokenizer(s," ");
        ArrayList list=new ArrayList();
        while (t.hasMoreTokens()) {
            String r=t.nextToken().trim();
            if (r.length()>1) {
            	r=r.substring(1,r.length()-1);
            	list.add(r);
            }
        }
        String[] out=new String[list.size()];
        list.toArray(out);
        return out;
    }
}
