/* 	NewsGroup.java
 *	Copyright (c) 2008, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Feb 25, 2008
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.message;

import java.util.Date;
import java.util.List;

import org.brains2b.saxo.SAXWriter;
import org.xml.sax.SAXException;

/**
 * Interface defining the necessary functions for a NewsGroup
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 0.90 [25-02-2008]
 */
public interface NewsGroup extends NNTPMessage {

	public abstract boolean isAllowPost();

	public abstract void setAllowPost(boolean allowPost);

	public abstract int getFirst();

	public abstract void setFirst(int first);

	public abstract int getLast();

	public abstract void setLast(int last);

	public abstract Date getLastUpdated();

	public abstract void setLastUpdated(Date lastUpdated);

	public abstract String getName();

	public abstract void setName(String name);
	
	public abstract int getEstimate();

	public abstract void setEstimate(int estimate);

	public abstract void addArticle(Article a);

	public abstract void removeArticle(Article a);

	public abstract List getArticleList();

	public abstract void setArticleList(List articleList);
	
	public void writeList(SAXWriter sw) throws SAXException;
	

}