/* 	FilterGroupList.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 27-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.message.filter;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.brains2b.coffee.message.GroupList;
import org.brains2b.coffee.message.NewsGroup;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class FilterGroupList extends GroupList implements FilterTarget {
    private GroupList m_groupList;
    private List m_filters;
    private int m_size=-1;
    
    public FilterGroupList(GroupList list, List filters) {
        super();
        m_groupList=list;
        m_filters=filters;
    }
    
    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.GroupList#getGroup(java.lang.String)
     */
    public NewsGroup getGroup(String name) {
        return m_groupList.getGroup(name);
    }
    
    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.GroupList#getGroupNames()
     */
    public List getGroups() {
        
        List out=new ArrayList();
        List groups=m_groupList.getGroups();
        for (Iterator it = groups.iterator(); it.hasNext();) {
        	NewsGroup n = (NewsGroup) it.next();
        	boolean add=true;
        	boolean remove=false;
        	for (Iterator itf = m_filters.iterator();itf.hasNext();) {
        		MessageFilter mf = (MessageFilter) itf.next();
        		add = add && mf.isValid(n.getName());
        		remove =remove || (!add && mf.isKill());
        	}
        	if (add) out.add(n);
        	if (remove) it.remove();
        }
        m_size=out.size();
        return out;
        
    }

    public int getSize() {
        return m_groupList.getSize();
    }
    
    public int getFilteredSize() {
    	if (m_size==-1) {
    		getGroups();
    	}
        return m_size;
    }
}
