/* 	FileMessage.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 29-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.brains2b.coffee.message.local;

import java.io.File;

import org.brains2b.saxo.SAXWriter;
import org.xml.sax.SAXException;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class FileMessage extends LocalMessage {
	//TODO FileMessage has an unclear implementation
    private File m_file;
    private String m_mimeType;
    private byte[] m_data;
    private Object m_content;
    private File m_tempFile;
    private int m_blockSize;
    private Options m_options;
    
    public FileMessage() {
    	super();
    }
    
    public FileMessage(File f, String mimeType) {
    	super();
    	m_file= f;
    	m_mimeType=mimeType;
    }
    
    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#getType()
     */
    public int getType() {
        return 0;
    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#writeMessage(org.brains2b.saxo.SAXWriter)
     */
    public void writeMessage(SAXWriter sw) throws SAXException {
    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#hasContent()
     */
    public boolean hasContent() {
        return m_content!=null;
    }

    /* (non-Javadoc)
     * @see org.brains2b.coffee.message.NNTPMessage#getSize()
     */
    public int getSize() {
        return 1;
    }

    public Object getContent() {
        return m_content;
    }
    public void setContent(Object content) {
        m_data=null;
        m_content = content;
    }
    public byte[] getData() {
        return m_data;
    }
    public void setData(byte[] data) {
        m_data = data;
    }
    public File getFile() {
        return m_file;
    }
    public void setFile(File file) {
        m_file = file;
    }
    public String getMimeType() {
        return m_mimeType;
    }
    public void setMimeType(String mimeType) {
        m_mimeType = mimeType;
    }

    public File getTempFile() {
        return m_tempFile;
    }

    public void setTempFile(File tempFile) {
        m_tempFile = tempFile;
    }
    
    public String getId() {
        return m_file.getAbsolutePath();
    }

    //TODO Options do not belong here!
	public Options getOptions() {
		return m_options;
	}

	public void setOptions(Options options) {
		m_options = options;
	}

	public int getBlockSize() {
		return m_blockSize;
	}

	public void setBlockSize(int blockSize) {
		m_blockSize = blockSize;
	}
}
