/* 	TicketQueueTest.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 10-aug-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee;

import java.util.Iterator;

import junit.framework.TestCase;

import org.brains2b.coffee.Ticket;
import org.brains2b.coffee.TicketQueue;
import org.brains2b.coffee.event.CoffeeEvent;

import test.org.brains2b.coffee.dummy.CeDummy;
import test.org.brains2b.coffee.dummy.CecDummy;


/** Unit test for TicketQueue
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version 1.00 [Nov 22, 2008]
 */
public class TicketQueueTest extends TestCase {


    /*
     * Test method for 'org.brains2b.coffee.TicketQueue.add(Ticket)'
     */
    public void testQueue() {
         TicketQueue queue=new TicketQueue();
         CeDummy dum = new CeDummy();
         CecDummy dummy=new CecDummy();
         int idx=0;
         CoffeeEvent e=new CoffeeEvent(dum,++idx,null);
         queue.add(getDummyTicket(e));
         e=new CoffeeEvent(dum,++idx,null);
         queue.add(getDummyTicket(e));
         e=new CoffeeEvent(dummy,++idx,null);
         queue.add(getDummyTicket(e));
         assertTrue(!queue.isEmpty());
         Iterator it=queue.iterator();
         int cnt=0;
         while (it.hasNext()) {
             Ticket t=(Ticket) it.next();
             if (cnt==0) {
                assertEquals(1,t.getEvent().getID());
                assertEquals(1,t.getSequence());
            } else if (cnt==1) {
                assertEquals(2,t.getEvent().getID());
                assertEquals(3,t.getSequence());
            } else if (cnt==2) {
                assertEquals(3,t.getEvent().getID());
                assertEquals(1000005,t.getSequence());
            }
             cnt++;
         }
    }
    
    private Ticket getDummyTicket(CoffeeEvent e) {
        Ticket t=new Ticket(null,e);
        return t;
    }

}
