package test.org.brains2b.coffee.file;

import java.io.IOException;

import org.brains2b.coffee.file.FilterHandler;
import org.brains2b.coffee.message.filter.FilterList;
import org.brains2b.coffee.message.filter.MessageFilter;
import org.brains2b.saxo.SAXReader;
import org.brains2b.util.DateHelper;
import org.xml.sax.SAXException;

import junit.framework.TestCase;

public class FilterHandlerTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}
	
	public void testFilterHandler() throws SAXException, IOException{
		MessageFilter allS = new MessageFilter("Subject", "contains","Test");
		MessageFilter allD = new MessageFilter("Date", "lesser",DateHelper.isoToDate("2010-12-30"));
		MessageFilter tstS = new MessageFilter("Subject", "Test");
		
		FilterHandler filter = new FilterHandler();
		SAXReader reader = new SAXReader();
		reader.setContentHandler(filter);
		reader.parse("test/filters.xml");
		
		FilterList fl = (FilterList) filter.getMessage();
		assertTrue(fl.getAllFilters(FilterList.ALL).contains(allS));
		assertTrue(fl.getAllFilters(FilterList.ALL).contains(allD));
		assertTrue(fl.getAllFilters("alt.test").contains(tstS));
	}

}
