package test.org.brains2b.coffee.message.local;

import java.io.File;
import java.io.StringWriter;

import org.brains2b.coffee.message.local.CoffeeMenu;
import org.brains2b.coffee.message.local.Options;
import org.brains2b.liken.LikenException;
import org.brains2b.liken.xml.XmlCompare;
import org.brains2b.saxo.SAXWriter;
import org.xml.sax.SAXException;

import junit.framework.TestCase;

public class CoffeeMenuTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testCoffeeMenu() throws SAXException, LikenException {
		CoffeeMenu menu = new CoffeeMenu("options", Options.class);
		
		assertEquals("options",menu.getId());
		assertFalse(menu.hasContent());
		
		Options options = (Options) menu.createBean();
		options.setId("binary");
		options.setBoolean("show-file-count", true);
		options.setString("encoding", "yEnc");
		options.setInt("block-size", 1024);
		
		assertTrue(menu.hasContent());
		
		menu.remove(options);
		assertEquals(0,menu.getList().size());
		assertFalse(menu.hasContent());
		menu.add(options);
		assertTrue(menu.hasContent());
		
		assertEquals(1,menu.getList().size());
		assertTrue(menu.getList().contains(options));
		
		StringWriter buf = new StringWriter();
		SAXWriter sw = new SAXWriter(buf);
		menu.writeMessage(sw);
		XmlCompare xml = new XmlCompare();
		boolean b = xml.compare(new File("test/optionz.xml"), buf.toString());
		assertTrue(xml.getReport(), b);
	}
}
