package test.org.brains2b.coffee.message.local;

import java.io.File;
import java.io.StringWriter;

import org.brains2b.coffee.message.local.Options;
import org.brains2b.liken.LikenException;
import org.brains2b.liken.xml.XmlCompare;
import org.brains2b.saxo.SAXWriter;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.AttributesImpl;

import junit.framework.TestCase;

public class OptionsTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testOptions() throws SAXException, LikenException{
		Options options = new Options("binary");
		options.setBoolean("show-file-count", true);
		options.setBoolean("show-filename", true);
		options.setString("encoding", "yEnc");
		options.setInt("block-size", 1024);
		
		assertEquals("binary", options.getId());
		assertEquals(Options.OPTIONS, options.getType());
		
		assertTrue(options.getBoolean("show-file-count"));
		assertTrue(options.getBoolean("show-filename"));
		assertEquals("yEnc", options.getString("encoding"));
		assertEquals(1024,options.getInt("block-size"));
		
		StringWriter buf = new StringWriter();
		SAXWriter sw = new SAXWriter(buf);
		options.writeMessage(sw);
		XmlCompare xml = new XmlCompare();
		boolean b = xml.compare(new File("test/binaryoptions.xml"), buf.toString());
		assertTrue(xml.getReport(), b);
	}
	
	public void testOptionsXml() throws SAXException, LikenException{
		Options options = new Options();
		
		AttributesImpl atts= new AttributesImpl();
		atts.addAttribute(null, null, "id", "CDATA", "binary");
		options.setAttributes(atts);
		assertEquals("binary", options.getId());
		
		atts= new AttributesImpl();
		atts.addAttribute(null, null, "id", "CDATA", "show-file-count");
		options.setContent("option", atts, "true");
		atts= new AttributesImpl();
		atts.addAttribute(null, null, "id", "CDATA", "encoding");
		options.setContent("option", atts, "yEnc");
		atts= new AttributesImpl();
		atts.addAttribute(null, null, "id", "CDATA", "block-size");
		options.setContent("option", atts, "1024");
		
		assertTrue(options.getBoolean("show-file-count"));
		assertFalse(options.getBoolean("show-filename"));
		assertEquals("yEnc", options.getString("encoding"));
		assertEquals(1024,options.getInt("block-size"));
		
	}
}
