/* 	MessageParserTest.java
 *	Copyright (c) 2010, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: Jun 30, 2010
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.nntp;

import java.io.BufferedReader;
import java.io.FileReader;

import junit.framework.TestCase;

import org.brains2b.coffee.message.GroupList;
import org.brains2b.coffee.nntp.MessageParser;

public class MessageParserTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	public void testChar() throws Exception {
		BufferedReader fr = new BufferedReader(new FileReader("test/grouplist.ntp"));
		MessageParser parser= new MessageParser();
		long start = System.currentTimeMillis();
		parser.start();
		int c= fr.read();
		while (c!=-1) {
			parser.addChar((char) c);
			c= fr.read();
		}
		fr.close();
		System.out.println("duration: " + (System.currentTimeMillis()-start)+ " ms" );
		
		assertTrue(parser.getMessage() instanceof GroupList);
		assertEquals(54810,parser.getMessage().getSize());
		parser.end();
	}
	
	public void testChars() throws Exception {
		BufferedReader fr = new BufferedReader(new FileReader("test/grouplist.ntp"));
		MessageParser parser= new MessageParser();
		long start = System.currentTimeMillis();
		parser.start();
		char[] b = new char[2048];
		int len = 0;
		while ((len=fr.read(b))!=-1) {
			parser.addChars(b,0,len);
		}
		fr.close();
		System.out.println("duration: " + (System.currentTimeMillis()-start)+ " ms" );
		
		assertTrue(parser.getMessage() instanceof GroupList);
		assertEquals(54810,parser.getMessage().getSize());
		parser.end();
	}
}
