/* 	NNTPConnectorTest.java
 *	Copyright (c) 2005, Brains2B.org
 *	
 *	Created by: Dennis Groenendijk
 *	Created on: 16-jul-2005
 *
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that  * the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
 * the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and
 * the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * 3. The name of the author may not be used to endorse or promote products derived from this software 
 * without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package test.org.brains2b.coffee.nntp;

import junit.framework.TestCase;

import org.brains2b.coffee.nntp.NNTPConnector;

/** [Short description]
 *  [Long description]
 *
 * @author <A HREF="MAILTO:dennis@brains2b.nl">dennis@brains2b.nl</A>
 * @version [version] [lastrevisiondate]
 */
public class NNTPConnectorTest extends TestCase {

    private NNTPConnector m_con;
    
    public static void main(String[] args) {
        junit.swingui.TestRunner.run(NNTPConnectorTest.class);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
   		m_con=new NNTPConnector("newszilla.xs4all.nl",119);
        m_con.connect();
    }

    /*
     * @see TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
        m_con.close();
    }
    
    public void testHelp() throws Exception {
      	System.out.println(m_con.invoke("HELP"));
    }
    
    /* NO LONGER SUPPORTED Returns  '211 Articles will follow' 
     * public void testListGroup() throws Exception {
     	System.out.println(m_con.invoke("LISTGROUP","alt.binaries.ftd"));
    }*/

    public void testGroup() throws Exception {
  	    System.out.println(m_con.invoke("GROUP","alt.binaries.ftd"));
    }
    
    public void testBody() throws Exception{
   	    System.out.println(m_con.invoke("GROUP","alt.binaries.ftd"));
   	    System.out.println(m_con.invoke("BODY","1926112"));
    }
    
    public void testArticle() throws Exception {
 	    System.out.println(m_con.invoke("GROUP","alt.binaries.ftd"));
 	    System.out.println(m_con.invoke("ARTICLE","1926112"));
    }
    
    /*public void testListActive() {
     	try {
     	    System.out.println(m_con.invoke("LIST","active"));
     	} catch (Exception ex) {
            ex.printStackTrace();
        }
    }*/
}
